

#include <Adafruit_DotStar.h>
#include <SPI.h>

#define NUMPIXELS 8 // Number of LEDs in strip

#define DATAPIN    4
#define CLOCKPIN   5
Adafruit_DotStar strip = Adafruit_DotStar(
                           NUMPIXELS, DATAPIN, CLOCKPIN, DOTSTAR_BRG);
//setup the strip. Don't worry about this jsut make sure you define the pion numbers you want to use



int led_pin1 = 6;
int ledState1 = LOW;
int pixel1;
unsigned long previousMillis1;
long rate1;
unsigned long previousMillis2;
long rate2;
unsigned long currentMillis;

int pot_value;

int wave1_latch;
int wave2_latch;
int wave1;
int wave2;

int wave1_max = 200;
int wave1_min = 50;

int wave2_max = 10;
int wave2_min = -10;
int pot1_value;

int led_output1;



void setup() {
  strip.begin(); // Initialize pins for output
  strip.show();  // Refresh strip
  strip.setBrightness(64); //sets the overall brightness, nomatter what you send the pixels later on.

  Serial.begin(9600); //turn serial communication with the computer on. (9600) describes the rate of transition and really doesn't need to be changed.

  pinMode(led_pin1, OUTPUT);
  wave1 = wave1_min;
  wave2 = wave2_min;
}


void loop()
{

  pot_value = analogRead(A0); // analogRead will return a value from 0 to 1023
  pot1_value = analogRead(A1); // analogRead will return a value from 0 to 1023

  pot1_value = map(pot1_value, 0, 1023, 0, 7);
  currentMillis = millis(); // only need to do this once

  rate1 =   20;

  if (currentMillis - previousMillis1 > rate1) {
    previousMillis1 = currentMillis;

    for (uint16_t i = 0; i < strip.numPixels(); i++) {
      strip.setPixelColor(i, 0);
    }

    pixel1++;
    if (pixel1 > strip.numPixels()) {
      pixel1 = 0;
    }
    strip.setPixelColor(pot1_value, Wheel(pot_value / 4));

    wave1_max = 200;
    wave1_min = 20;

    if (wave1_latch == 1) {
      wave1 += 2;
    }

    if (wave1_latch == 0) {
      wave1 -= 4;
    }

    if (wave1 >= wave1_max) {
      wave1_latch = 0;
    }

    if (wave1 <= wave1_min) {
      wave1_latch = 1;
    }

    strip.show();


  }

  rate2 = 2;

  if (currentMillis - previousMillis2 > rate2) {
    previousMillis2 = currentMillis;

    wave2_max = 15;
    wave2_min = -15;


    if (wave2_latch == 1) {
      wave2 += 2;
    }

    if (wave2_latch == 0) {
      wave2 -= 2;
    }

    if (wave2 >= wave2_max) {
      wave2_latch = 0;
    }

    if (wave2 <= wave2_min) {
      wave2_latch = 1;
    }

  }

  led_output1 = wave1 + wave2 ;
  analogWrite(led_pin1, led_output1); // can output 256 values


}

uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if (WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if (WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}
